function Ger96700_tipoFiscalizacaoProduto(General, templateManager, ScreenService) {

    this.ativaAction = function(name) {
        if(name == 'WidgetOnOpenDetail'){
            templateManager.container.getWidget('widgetTipoFiscalizacao').getAction('voltarTpFiscalizacao').isVisible = true;
        }
        if(name == 'adicionarClassFiscal' || name == 'editClassFiscal'){  
            templateManager.container.getWidget('widgetClasFiscalControlados').getAction('voltarClassfiscal').isVisible = false;
            templateManager.container.getWidget('widgetClasFiscalControlados').getAction('cancelarClasFiscal').isVisible = true;
        }    
        if(name == 'cancelarTpAlvara'){
            templateManager.container.getWidget('widgetTpAlvaraLicenca').getAction('cancelarTpAlvara').isVisible = false;
            templateManager.container.getWidget('widgetTpAlvaraLicenca').getAction('voltarTpAlvara').isVisible = false;
        }
        if(name == 'adicionarTpAlvara'){
            templateManager.container.getWidget('widgetTpAlvaraLicenca').getAction('cancelarTpAlvara').isVisible = true;
            templateManager.container.getWidget('widgetTpAlvaraLicenca').getAction('voltarTpAlvara').isVisible = false;
        }   
        if(name == 'cancelarClasFiscal'){
            templateManager.container.getWidget('widgetClasFiscalControlados').getAction('voltarClassfiscal').isVisible = true;
            templateManager.container.getWidget('widgetClasFiscalControlados').widgets[0].enabled = true;
            templateManager.container.getWidget('widgetClasFiscalControlados').getField('SGUNIDPADR').isVisible = true;
            templateManager.container.getWidget('widgetClasFiscalControlados').getField('SGUNIDADE').isVisible = false;
        }
        if(name == 'voltar'){
            templateManager.container.getWidget('widgetTipoFiscalizacao').getAction('voltarTpFiscalizacao').isVisible = true;
            templateManager.container.getActiveWidget().reload();
        }
        if(name == 'salvarProdSemAlvara' || name == 'cancelarProdSemAlvara'){
            templateManager.container.getWidget('widgetGridProdSemALvara').getAction('voltarProdSemAlvara').isVisible = true;
            templateManager.container.getWidget('widgetGridProdSemALvara').getAction('cancelarProdSemAlvara').isVisible = false;
            templateManager.container.getWidget('widgetGridProdSemALvara').label = '';
        }
        if(name == 'cancelarTpAlvara' || name == 'salvarTpAlvara'){
            templateManager.container.getWidget('widgetTpAlvaraLicenca').getField('NMALVARA').readOnly = false;
            templateManager.container.getWidget('widgetTpAlvaraLicenca').getAction('voltarTpAlvara').isVisible = true;
            templateManager.container.getWidget('widgetTpAlvaraLicenca').getAction('cancelarTpAlvara').isVisible = false;
        }
        if(name == 'editTpAlvara'){
            templateManager.container.getWidget('widgetTpAlvaraLicenca').getAction('voltarTpAlvara').isVisible = false;
            templateManager.container.getWidget('widgetTpAlvaraLicenca').getAction('cancelarTpAlvara').isVisible = true;
        }
        if(name == 'salvarClasFiscal'){
            templateManager.container.getWidget('widgetClasFiscalControlados').getAction('voltarClassfiscal').isVisible = true;
            templateManager.container.getWidget('widgetTipoFiscalizacao').getAction('voltarTpFiscalizacao').isVisible = true;
            templateManager.container.getWidget('widgetClasFiscalControlados').widgets[0].enabled = true;
            
        }
        
    };
    
    this.create = function(widget, nameAction){
        widget.reload();
        widget.newRow();
        widget.currentRow.__is_new = true;
        
        if(nameAction == 'adicionarTpFiscalizacao')
            this.addTpFiscalizacao();
        else if(nameAction == 'adicionarClassFiscal')
            this.addClassFiscal(widget);
        if(nameAction == 'adicionarTpAlvara')
            this.adicionarTpAlvara(widget);
    };  
    
    this.cancel = function(widget){
        if(widget.currentRow.__is_new === true){
            widget.dataSource.data.pop();
            ScreenService.closeSwipe();
        } else {
            Util.extend(widget.currentRow, widget.backupRow);
            widget.view();
        }
        widget.reload();
    };
	

    this.addTpFiscalizacao = function(){
        var widget = templateManager.container.getWidget('widgetTipoFiscalizacao');
        var dados = widget.dataSource.data;
        
        if(dados.length == 0){
            widget.getField('NRTPFISCALPROD').setValue('01');
        }else{
            var aux = 0;
            for(var i = 0; i < dados.length; i++){
                if(dados[i].NRTPFISCALPROD > aux){
                    aux = dados[i].NRTPFISCALPROD;
                }
            }
            aux++;
            widget.getField('NRTPFISCALPROD').setValue(aux);
            widget.getField('NMTPFISCALPROD').readOnly = false;
        }
        
        this.ativaWidget(widget, 'adicionaTpFiscalizacao');
    };
    
    this.ativaWidget = function(widget, name){
        if (name == 'salvarTpFiscalizacao' || name == 'cancelarTpFiscalizacao'){
            
            if(name == 'salvarTpFiscalizacao'){
                widget.getAction('voltarTpFiscalizacao').isVisible = true;
                widget.getAction('cancelarTpFiscalizacao').isVisible = false;
            }else if(name == 'cancelarTpFiscalizacao'){
                widget.getAction('voltarTpFiscalizacao').isVisible = true;
                widget.getAction('cancelarTpFiscalizacao').isVisible = false;
            }
            
            widget.widgets[0].isVisible = true;
            widget.widgets[1].isVisible = true;
            
            widget.widgets[0].enabled = true;
            widget.widgets[1].enabled = true;
            
        }else if(name == 'adicionaTpFiscalizacao'){
            
            widget.getAction('voltarTpFiscalizacao').isVisible = false;
            widget.getAction('cancelarTpFiscalizacao').isVisible = true;
            
            widget.widgets[0].isVisible = false;
            widget.widgets[1].isVisible = false;
        }
        
    };
    
    this.editTpFiscalizacao = function(widget){
        General.edit(widget);
        
        widget.getField('NMTPFISCALPROD').readOnly = false;
        widget.getAction('voltarTpFiscalizacao').isVisible = false;
        widget.getAction('cancelarTpFiscalizacao').isVisible = true;
        
        widget.widgets[0].enabled = false;
        widget.widgets[1].enabled = false;
    };
    
    this.excluirTpFiscalizacao = function(widget){
        General.callRestEngine('ped_pedidos#/ncmcontrolados_clasfiscal', 'Row', widget.currentRow).then(function(){
            var widget = templateManager.container.getWidget('widgetTipoFiscalizacao');
            General.deleteCrud(widget);
        }.bind(this));
        
        
    };
    
    this.cadastroAutomatico = function(){
        templateManager.container.getWidget('widgetCadastroAutomatico').isVisible = false;
        var widget = templateManager.container.getWidget('widgetCadastroAutomatico');
        widget.getField('FILTRAR').setValue("T");
        widget.getField('NMTPFISCALPROD').reload();
        this.cancelaCadastramento(widget);
        ScreenService.openPopup(widget);    
    };
    
    this.changeFiltro = function(){
        var widget = templateManager.container.getWidget('widgetCadastroAutomatico');
        var field = widget.getField('FILTRAR').value();
        if(field == 'L'){
            widget.getField('DSCLASFISC').readOnly = false;
        }
    };
    
    this.salvarCadastramento = function(){
        var widget = templateManager.container.getWidget('widgetCadastroAutomatico');
        var dataSet = [];
        var row = {};
        var cdclasfisc = widget.getField('CDCLASFISC').value();
        var filtro = widget.getField('FILTRAR').value();
        
        var un = widget.getField('SGUNIDADE').value();
        widget.getField('SGUNIDPADR').setValue(un);
        
        var qtmensal = widget.getField('QTMENSAL').value();
        var qtmensalCorreto;
        if(qtmensal > "0"){
            if((widget.fields[0].value() != " ") && (widget.fields[1].value() != " ") && (widget.fields[3].value() != " ") && (widget.fields[4].value() != " ") && (widget.fields[5].value() != " ")){
                if(isNaN(qtmensal)){
                    if(qtmensal.indexOf(",") >= 0){
                        qtmensalCorreto = qtmensal.replace(',','.');
                        widget.getField('QTMENSAL').setValue(qtmensalCorreto);
                        this.salvarCadastramento();
                    }else{
                        ScreenService.showMessage("O campo 'Qt. Mensal' deve conter apenas números.");
                        widget.getField('QTMENSAL').setValue("0");
                    }
                }else{
                    var aux2;
                    
                    if(qtmensal.indexOf(",") >= 0){
                        qtmensalCorreto = qtmensal.replace(',','.');
                        aux2 = Number.parseFloat(qtmensalCorreto).toFixed(3);
                    }else{
                        aux2 = Number.parseFloat(qtmensal).toFixed(3);
                    }
                    
                    var tamanho = aux2.length;
                    var numArrendodado;
                    
                    if(aux2[tamanho - 1] > 5){
                        numArrendodado = Number.parseFloat(aux2).toFixed(2);
                        widget.getField('QTMENSAL').setValue(numArrendodado);
                    }else{
                        widget.getField('QTMENSAL').setValue(aux2);
                    }
                    
                    widget.reload();
                    var nrorg = widget.dataSource.data[0].NRORG;
                    if(filtro == "L"){
                        if(widget.fields[7].value() != " "){
                            for(var i = 0; i < cdclasfisc.length; i++){
                            
                                row = {
                                    "NRTPFISCALPROD": widget.getField('NRTPFISCALPROD').value(),
                                    "CDCLASFISC": cdclasfisc[i],
                                    "SGUNIDPADR": widget.getField('SGUNIDADE').value(),
                                    "QTMENSAL": widget.getField('QTMENSAL').value(),
                                    "NRORG": nrorg
                                };
                                dataSet.push(row);
                                //this.salvar(row);
                            }
                            this.salvar(dataSet);
                        }else{
                            ScreenService.showMessage("Preencha todos os campos para realizar o cadastramento automático.");
                        }  
                    }else if(filtro == "T"){
                        row = {
                                "NRTPFISCALPROD": widget.getField('NRTPFISCALPROD').value(),
                                "SGUNIDPADR": widget.getField('SGUNIDADE').value(),
                                "QTMENSAL": widget.getField('QTMENSAL').value(),
                                "NRORG": nrorg
                        };
                            
                        General.callRestEngine('ped_pedidos#/select_clasfiscal', 'Row', row).then(function(callback){
                            ScreenService.closePopup();
                            ScreenService.showMessage("Cadastramento automático realizado com sucesso.");
                        }).catch(function(error){
                            ScreenService.showMessage("Impossível adicionar, registro já existe.");
                        });
                        
                    }
                }
            }else{
                ScreenService.showMessage("Preencha todos os campos para realizar o cadastramento automático.");
            }
        }else if(qtmensal <= "0"){
            widget.getField('QTMENSAL').setValue("");
        }
    };
    
    this.salvar = function(dataSet){
        General.callRestEngine('ped_pedidos#/cadastro_automatico', 'DataSet', dataSet).then(function(){
            ScreenService.closePopup();
            ScreenService.showMessage("Cadastramento automático realizado com sucesso.");
        }).catch(function(error){
            ScreenService.showMessage("Impossível adicionar, registro já existe.");
        });
    };
    
    this.cancelaCadastramento = function(widget){
      for(var j = 0; j < widget.fields.length; j++ ){
            if(j == 5){
                widget.fields[j].setValue("T");
            }else{
                widget.fields[j].setValue(" ");
            }
        }
        widget.fields[7].readOnly = true;  
    };
    
   
    this.addClassFiscal = function(widget){
        var aux = templateManager.container.getWidget('widgetTipoFiscalizacao').getField('NRTPFISCALPROD').value();
        widget.getField('NRTPFISCALPROD').setValue(aux);
        widget.getField('DSCLASFISC').readOnly = false;
        widget.getField('SGUNIDPADR').isVisible = false;
        widget.getField('SGUNIDADE').isVisible = true;
    };
    
    this.editClassFiscal = function(widget){
      General.edit(widget);  
      
      widget.getField('DSCLASFISC').readOnly = true;
      widget.getField('SGUNIDPADR').readOnly = true;
      widget.widgets[0].enabled = false;
    };
    
    this.saveClasFiscal = function(widget){
        if(widget.currentRow.__is_new == true){
            var un = widget.getField('SGUNIDADE').value();
            var aux = un.toUpperCase();
            widget.getField('SGUNIDPADR').setValue(aux);
        }
        
        widget.getField('SGUNIDADE').isVisible = false;
        widget.getField('SGUNIDPADR').isVisible = true;
        
        var qtmensal = widget.getField('QTMENSAL').value();
        if(qtmensal > "0"){
            
            var qtmensalCorreto;
            if(isNaN(qtmensal)){
                if(qtmensal.indexOf(",") >= 0){
                    qtmensalCorreto = qtmensal.replace(',','.');
                    widget.getField('QTMENSAL').setValue(qtmensalCorreto);
                    this.saveClasFiscal(widget);
                }else{
                    ScreenService.showMessage("O campo 'Qt. Mensal' deve conter apenas números.");
                    widget.getField('QTMENSAL').setValue("0");
                }
            }else{
                var aux2;
                
                if(qtmensal.indexOf(",") >= 0){
                    qtmensalCorreto = qtmensal.replace(',','.');
                    aux2 = Number.parseFloat(qtmensalCorreto).toFixed(3);
                }else{
                    aux2 = Number.parseFloat(qtmensal).toFixed(3);
                }
                
                var tamanho = aux2.length;
                var numArrendodado;
                
                if(aux2[tamanho - 1] > 5){
                    numArrendodado = Number.parseFloat(aux2).toFixed(2);
                    widget.getField('QTMENSAL').setValue(numArrendodado);
                }else{
                    widget.getField('QTMENSAL').setValue(aux2);
                }
                
                widget.reload();
                
                General.saveCrud(widget);
            }
        }else if(qtmensal <= "0"){
            widget.getField('QTMENSAL').setValue("");
        }
    };
    
    
    this.editTpAlvaraLicenca = function(widget){
        General.edit(widget);
        widget.getField('NMALVARA').readOnly = true;
    };
    
    this.verificaTpAlvara = function(widget){
        var fields = widget.fields;
        var aux = false;
        
        for(var i = 3; i < fields.length; i++){
            if(fields[i].value() == 'S'){
                aux = true;
            }    
        }
        
        if(aux == true){
            General.saveCrud(widget);
        }else{
            ScreenService.showMessage("Pelo menos um dos campos: 'Cliente', 'Filial', 'Fornecedor' e 'Transportadora' deve estar com a opção 'Exige' selecionada.");
        }
    };
    
    this.adicionarTpAlvara = function(widget){
        var nrtpfiscalprod = widget.getParent().getField('NRTPFISCALPROD').value();
        widget.getField('NRTPFISCALPROD').setValue(nrtpfiscalprod);
        
    };
    
    
    this.changeLabel = function(widget, name){
        if(name == 'WidgetOnOpenDetail'){
            templateManager.container.getWidget('widgetGridProdSemALvara').label = 'Produtos sem Alvará';    
        }else if(name == 'voltarProdSemAlvara'){
            widget.label = ' ';    
            if(templateManager.container.getActiveWidget().name == 'widgetTipoFiscalizacao'){
                templateManager.container.getWidget('widgetProdSemAlvara').fields[0].setValue(' ');
                templateManager.container.getWidget('widgetProdSemAlvara').fields[1].setValue(' ');
                templateManager.container.getWidget('widgetProdSemAlvara').fields[2].setValue(' ');
                templateManager.container.getWidget('widgetProdSemAlvara').fields[3].setValue(' ');
            }
        }
        
        templateManager.container.getWidget('widgetGridProdSemALvara').reload();
    };
    
    this.editProdSemAlvara = function(widget){
        General.edit(widget);
        widget.getAction('cancelarProdSemAlvara').isVisible = true;
        widget.getAction('voltarProdSemAlvara').isVisible = false;
    };
    
    this.setCampos = function(){
        var widget = templateManager.container.getWidget('widgetClasFiscalControlados');
        var dsclasfisc = widget.getField('DSCLASFISC').value();
        var sgunidpadr = widget.getField('SGUNIDPADR').value();
        var cdclasfisc = widget.getField('CDCLASFISC').value();
        var qtmensal = widget.getField('QTMENSAL').value();
        
        var prodsemalvara = templateManager.container.getWidget('widgetProdSemAlvara');
        prodsemalvara.getField('CDCLASFISC').setValue(cdclasfisc);
        prodsemalvara.getField('DSCLASFISC').setValue(dsclasfisc);
        prodsemalvara.getField('QTMENSAL').setValue(qtmensal);
        prodsemalvara.getField('SGUNIDPADR').setValue(sgunidpadr);
        
        templateManager.container.getWidget('widgetGridProdSemALvara').reload();
    };
    
}

Configuration(function(ContextRegister){
    ContextRegister.register('Ger96700_tipoFiscalizacaoProduto', Ger96700_tipoFiscalizacaoProduto);
});

